import Task from '@dojo/core/async/Task';
/**
 * Creates a promise that resolves itself after `ms` milliseconds.
 *
 * @param ms Time until resolution in milliseconds.
 */
export declare function sleep(ms: number): Task<void>;
/**
 * Annotates the method with additional properties that provide guidance to [[Command]] about
 * how the method interacts with stored context elements.
 */
export declare function forCommand(fn: Function, properties: {
    usesElement?: boolean;
    createsContext?: boolean;
}): Function;
/**
 * Converts a function to a string representation suitable for use with the `execute` API endpoint.
 */
export declare function toExecuteString(fn: Function | string): string;
/**
 * Removes the first line of a stack trace, which in V8 is the string representation of the object holding the stack
 * trace (which is garbage for captured stack traces).
 */
export declare function trimStack(stack: string): string;
export declare function applyMixins(derivedCtor: any, baseCtors: any[], includePrivates?: boolean): void;
