"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Task_1 = require("@dojo/core/async/Task");
var statusCodes_1 = require("./statusCodes");
function waitForDeleted(session, locator, strategy, value) {
    var originalTimeout;
    return session.getTimeout('implicit').then(function (value) {
        originalTimeout = value;
        session.setTimeout('implicit', 0);
    }).then(function () {
        return new Task_1.default(function (resolve, reject) {
            var startTime = Date.now();
            (function poll() {
                if (Date.now() - startTime > originalTimeout) {
                    var always = function () {
                        var error = new Error();
                        error.status = 21;
                        var _a = statusCodes_1.default[error.status], name = _a[0], message = _a[1];
                        error.name = name;
                        error.message = message;
                        reject(error);
                    };
                    session.setTimeout('implicit', originalTimeout).then(always, always);
                    return;
                }
                locator.find(strategy, value).then(poll, function (error) {
                    var always = function () {
                        /* istanbul ignore else: other errors should never occur during normal operation */
                        if (error.name === 'NoSuchElement') {
                            resolve();
                        }
                        else {
                            reject(error);
                        }
                    };
                    session.setTimeout('implicit', originalTimeout).then(always, always);
                });
            })();
        });
    }).then(function () { });
}
exports.default = waitForDeleted;
//# sourceMappingURL=waitForDeleted.js.map